""" Some grabbag tools """

from pymbolic.primitives import Expression, Variable, Subscript


def get_pymbolic_basename(expr):
    assert isinstance(expr, Expression), "Type: {}, expr: {}".format(type(expr), expr)

    if isinstance(expr, Variable):
        return expr.name

    if isinstance(expr, Subscript):
        return get_pymbolic_basename(expr.aggregate)

    raise NotImplementedError("Cannot determine basename of {}".format(expr))